<! doctype html>
<html>
	<head>
		<title>Lyric by combination</title>
		<meta charset="utf-8"/>
		<style>
			*{padding:0px;margin:0px;overflow:hidden;}
			.cover{

			
			font-family:"微软雅黑"; font-size:22px; position:relative;left:0px;top:0px;height:100%;}
			.showcolor{color:blue;}
		</style>
	</head>
	<body bgcolor="black">
		<button id="playMusic">Press this button to paly</button>
		<audio style="display:none;"  id="audio" controls loop src="./ShanD_SIP-6534.wav" autoplay="autoplay">
		</audio>
		<div style="margin:30px auto;height:40px;line-height:40px;width:600px;">
			<div id="cover1" style="color:#00ffe9;" class="cover">
				
			</div>
			<div id="cover2" class="cover" style="color:#c79bff;top:-100%;">
				
			</div>
			<div id="cover3" class="cover" style="color:#c79bff;top:-200%;">
				
			</div>
			<div id="cover4" class="cover" style="color:#c79bff;top:-400%;">
				
			</div>
			
		<div>
		
		<script>
			
			let audio = document.getElementById('audio') ;
			let mControl = document.getElementById('playMusic') ;
			let lyric = "00:00.57]周杰伦 - 我不配  [00:01.40]词：方文山  [00:02.27]曲：周杰伦  [00:18.76]这街上太拥挤  [00:20.86]太多人有秘密  [00:23.07]玻璃上有雾气在被隐藏起过去  [00:27.54]你脸上的情绪  [00:29.76]在还原那场雨  [00:32.00]这巷弄太过弯曲走不回故事里  [00:36.41]这日子不再绿  [00:38.65]又斑驳了几句  [00:40.87]剩下搬空回忆的我在大房子里  [00:45.30]电影院的座椅  [00:47.56]隔遥远的距离  [00:49.77]感情没有对手戏你跟自己下棋  [00:53.91]还来不及仔仔细细写下你的关于  [01:02.89]描述我如何爱你  [01:06.71]你却微笑的离我而去  [01:11.62]这感觉 已经不对  [01:13.86]我努力在挽回  [01:16.09]一些些应该体贴的感觉我没给  [01:20.59]你嘟嘴许的愿望很卑微在妥协  [01:24.59]是我忽略 你不过要人陪  [01:29.26]这感觉已经不对  [01:31.61]我最后才了解  [01:33.90]一页页不忍翻阅的情节你好累  [01:38.28]你默背为我掉过几次泪多憔悴  [01:42.60]而我心碎你受罪你的美我不配  [02:05.43]这街上太拥挤  [02:07.54]太多人有秘密  [02:09.78]玻璃上有雾气在被隐藏起过去  [02:14.15]你脸上的情绪  [02:16.50]在还原那场雨  [02:18.67]这巷弄太过弯曲走不回故事里  [02:23.11]这日子不再绿  [02:25.32]又斑驳了几句  [02:27.51]剩下搬空回忆的我在大房子里  [02:31.96]电影院的座椅  [02:34.17]隔遥远的距离  [02:36.46]感情没有对手戏你跟自己下棋  [02:40.58]还来不及仔仔细细写下你的关于  [02:49.56]描述我如何爱你  [02:53.32]你却微笑的离我而去  [02:58.29]这感觉 已经不对  [03:00.52]我努力在挽回  [03:02.84]一些些应该体贴的感觉我没给  [03:07.26]你嘟嘴许的愿望很卑微在妥协  [03:11.34]是我忽略 你不过要人陪  [03:15.99]这感觉已经不对  [03:18.33]我最后才了解  [03:20.59]一页页不忍翻阅的情节你好累  [03:25.06]你默背为我掉过几次泪多憔悴  [03:29.14]而我心碎你受罪你的美我不配  [03:47.35]这感觉 已经不对  [03:49.43]我努力在挽回  [03:51.64]一些些应该体贴的感觉我没给  [03:56.14]你嘟嘴许的愿望很卑微在妥协  [04:00.42]是我忽略 你不过要人陪  [04:05.05]这感觉已经不对  [04:07.24]我最后才了解  [04:09.45]一页页不忍翻阅的情节你好累  [04:13.89]你默背为我掉过几次泪多憔悴  [04:18.08]而我心碎你受罪你的美我不配  " ;
			let lyrics = lyric.split("[") ;
			let lyObj = [] ; 
			for(let i = 0 ; i < lyrics.length ; ++i){
				let time = 0 ;
				let tmp1 = lyrics[i].split("]");
				let tmp2 = tmp1[0].split(":");
				time = parseInt(tmp2[0])*60 + parseFloat(tmp2[1]);
				lyObj.push({time:time,ly:tmp1[1]});
			}
			function findPosition(time){
				for(let i = 0 ; i < lyObj.length ; ++i){
					if(time < lyObj[i].time || i == lyObj.length - 1 ) {
						return i-1 > 0 ? i-1 :0  ;
					}  
				}
			}
			function getTimeDistance(i){
				if(i == lyObj.length - 1) return 5000 ;
				return parseInt(1000*(lyObj[i+1].time  - lyObj[i].time ));
			}
			
			let cover1 = document.getElementById("cover1");
			let cover2 = document.getElementById("cover2");
			let cover3 = document.getElementById("cover3");
			let cover4 = document.getElementById("cover4");
			let currentLen = 0 ;
			let dLen = 0 ;
			let timer = null ; 
			let last = -1 ; 
			function setLyric(str){
				cover1.innerText = str ; 
				cover2.innerText = str ; 
				cover3.innerText = str ; 
				cover4.innerText = str ; 
			}
			function setLength(len){
				cover2.style.width = len + "px"; 
				cover3.style.width = len + "px"; 
				cover4.style.width = len + "px"; 
			}
			audio.ontimeupdate = function(e){
				
				let i = findPosition(audio.currentTime) ; 
				if(last == i ) return ;
				last = i ; 
				let d = getTimeDistance(i) ;
				let l = lyObj[i].ly.length * 32 ;
				currentLen = 0 ; 
				dLen = l/d*3 ; 
				setLyric(lyObj[i].ly);
				setLength(currentLen);
				if(timer!=null)
				clearInterval(timer);
				timer = setInterval(function(){
					currentLen += dLen ; 
					setLength(currentLen) ; 
				},1);
			} ;
			mControl.onclick = function(){
				mControl.style.display = "none" ;
				audio.play();
			};
			
		</script>
	</body>
</html>